package userkindboxreqservice

import (
	"context"
	"git.gocasts.ir/ebhomengo/niki/entity"
	errmsg "git.gocasts.ir/ebhomengo/niki/pkg/err_msg"

	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/kind_box_req"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) Delete(ctx context.Context, req param.KindBoxReqDeleteRequest) (param.KindBoxReqDeleteResponse, error) {
	//TODO: Does bussiness domain need to delete an kindboxreq ?
	const op = "userkindboxreqservice.Delete"

	kbr, gErr := s.repo.GetKindBoxReq(ctx, req.KindBoxReqID)
	if gErr != nil {
		return param.KindBoxReqDeleteResponse{}, richerror.New(op).WithErr(gErr).WithKind(richerror.KindUnexpected)
	}
	if kbr.Status != entity.KindBoxReqPendingStatus {
		return param.KindBoxReqDeleteResponse{}, richerror.New(op).WithMessage(errmsg.ErrorMsgInvalidStatus).WithKind(richerror.KindInvalid)
	}
	if kbr.BenefactorID != req.BenfactorID {
		return param.KindBoxReqDeleteResponse{}, richerror.New(op).WithMessage(errmsg.ErrorMsgUserNotAllowed).WithKind(richerror.KindForbidden)
	}

	dErr := s.repo.DeleteKindBoxReq(ctx, req.KindBoxReqID)
	if dErr != nil {
		return param.KindBoxReqDeleteResponse{}, richerror.New(op).WithErr(dErr).WithKind(richerror.KindUnexpected)
	}

	return param.KindBoxReqDeleteResponse{}, nil
}
